/* 
 * File:   main.c
 * Author: Sahil Gupta
 *
 * Created on October 3, 2011, 1:07 PM
 */

///////////////////////////////GAME RULES///////////////////////////////////////
/*
This game is a combination of 4 levels in one screen. You start with hundred
points in the start of the game. Each level you cross will award you 100 points
more, 400 being the maximum score. There are three bricks/obstacles in this game.
You have to avoid these bricks/obstacles. If you touch them you loose the game.
The game is not that easy :( because you have to cross these levels without
touching the walls. If you touch the walls or the bricks/obstacles you loose the
game. There is a timer(in seconds) which keeps track of the time for you in the
game. You WIN this game by reaching the top right corner of the screen. The
overall score is the best parameter to measure your progress in the game.
Overall score is the quotient as a result of the division of the score and time
you take. Best of Luck!
*/
////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include "myLib.h"
#include "font.h"

#define COL_INIT 15
#define ROW_INIT 15
#define COL_DELTA 4
#define ROW_DELTA 4
#define SIZE 15

int main() {

    b b1;
    b b2;
    b b3;

    //set up display
    REG_DISPCTL = MODE3 | BG2_ENABLE;

    //variables initialized for face.
    int row = ROW_INIT;
    int col = COL_INIT;
    int size = SIZE;

    int oldrow = row;
    int oldcol = col;
    int oldsize = size;
    //over

    //Variables for printing all the data on the screen.

    char gameover[40] = "GAME OVER!! YOU LOSE";
    char win[40] = "YOU WIN THE GAME!! HURRAY!";

    //variables initialized for brick1.
    b1.row = ROW_INIT + 50;
    b1.col = COL_INIT + 50;
    b1.cdel = 4;
    b1.rdel = 4;
    b1.size = 15;

    b1.oldrow = b1.row;
    b1.oldcol = b1.col;
    //over

    //variables initialized for brick2.
    b2.row = ROW_INIT + 25;
    b2.col = COL_INIT + 200;
    b2.cdel = 4;
    b2.rdel = 4;
    b2.size = 20;

    b2.oldrow = b2.row;
    b2.oldcol = b2.col;
    //over

    //variables initialized for brick3.
    b3.row = 85;
    b3.col = 20;
    b3.cdel = 5;
    b3.rdel = 5;
    b3.size = 25;

    b3.oldrow = b3.row;
    b3.oldcol = b3.col;

    int TIMER = 0;
    
    int SECTIMER = 0;
    int OLDSECTIMER = SECTIMER;
    char timebuffer[41];

    int score = 0;
    int oldscore = score;
    char scorebuffer[41];

    int finalgamescore = 0;
    int oldfinalgamescore = finalgamescore;
    char finalscorebuffer[41];

    //over

    //loop for game starts here

    while (1) {

        ///////////////////Defines the path of the face/////////////////////////

        if (((row + SIZE) > 77) && ((col - SIZE) < 75) && ((row - SIZE) < 83)) {
            break;
        } else if (((col + SIZE) > 111) && (row - SIZE) < 122 && (col - SIZE) < 117) {
            break;
        } else if (((row - SIZE) < 122) && ((col - SIZE) < 207) && ((col + SIZE) > 111) && ((row + SIZE) > 118)) {
            break;
        } else if (((row - SIZE) < 83) && ((col + SIZE) > 152) && (row + SIZE) > 78) {
            break;
        } else {
            row = row;
            col = col;
        }


        ////////////////////////////////////////////////////////////////////////

        //the next four if statements change the direction of the face/player and
        //keep it within bounds.

        if (KEY_DOWN_NOW(BUTTON_UP)) {
            row = row - ROW_DELTA;
            if (row - size < 0) {
                row = size;
            }
        }
        if (KEY_DOWN_NOW(BUTTON_DOWN)) {
            row = row + ROW_DELTA;
            if ((row + size) > 159) {
                row = 159 - size;
            }
        }
        if (KEY_DOWN_NOW(BUTTON_RIGHT)) {
            col = col + COL_DELTA;
            if ((col + size) > 239) {
                col = 239 - size;
            }
        }
        if (KEY_DOWN_NOW(BUTTON_LEFT)) {
            col = col - COL_DELTA;
            if ((col - size) < 0) {
                col = size;
            }
        }
        ///////////////////////////////over/////////////////////////////////////

        if ((b1.col + b1.size > b2.col) && (b1.col < b2.col + b2.size))
            if ((b1.row + b1.size >= b2.row && b1.row < b2.row) || (b1.row <= b2.row + b2.size && b1.row > b2.row))
                b1.rdel = -b1.rdel;
        if ((b1.row + b1.size > b2.row) && (b1.row < b2.row + b2.size))
            if (b1.col + b1.size == b2.col || b1.col == b2.col + b2.size)
                b1.cdel = -b1.cdel;

        if ((b2.col + b2.size > b1.col) && (b2.col < b1.col + b1.size))
            if ((b2.row + b2.size >= b1.row && b2.row < b1.row) || (b2.row <= b1.row + b1.size && b2.row > b1.row))
                b2.rdel = -b2.rdel;
        if ((b2.row + b2.size > b1.row) && (b2.row < b1.row + b1.size))
            if (b2.col + b2.size == b1.col || b2.col == b1.col + b1.size)
                b2.cdel = -b2.cdel;

        if ((b2.col + b2.size > b3.col) && (b2.col < b3.col + b3.size))
            if ((b2.row + b2.size >= b3.row && b2.row < b3.row) || (b2.row <= b3.row + b3.size && b2.row > b3.row))
                b1.rdel = -b2.rdel;
        if ((b2.row + b2.size > b3.row) && (b2.row < b3.row + b3.size))
            if (b2.col + b2.size == b3.col || b2.col == b3.col + b3.size)
                b2.cdel = -b2.cdel;

        if ((b3.col + b3.size > b2.col) && (b3.col < b2.col + b2.size))
            if ((b3.row + b3.size >= b2.row && b3.row < b2.row) || (b3.row <= b2.row + b2.size && b3.row > b2.row))
                b3.rdel = -b3.rdel;
        if ((b3.row + b3.size > b2.row) && (b3.row < b2.row + b2.size))
            if (b3.col + b3.size == b2.col || b3.col == b2.col + b2.size)
                b3.cdel = -b3.cdel;

        /////////////////////collisions with face///////////////////////////////
        
                if ((b1.col + b1.size > (col - SIZE)) && (b1.col < (col - SIZE) + (2 * SIZE)))
                    if ((b1.row + b1.size >= (row - SIZE) && b1.row < (row - SIZE)) || (b1.row <= (row - SIZE) + (2 * SIZE) && b1.row > (row - SIZE)))
                        goto LOSE;
                if ((b1.row + b1.size > (row - SIZE)) && (b1.row < (row - SIZE) + (2 * SIZE)))
                    if (b1.col + b1.size == (col - SIZE) || b1.col == (col - SIZE) + (2 * SIZE))
                        goto LOSE;

                if (((col - SIZE) + (2 * SIZE) > b1.col) && ((col - SIZE) < b1.col + b1.size))
                    if (((row - SIZE) + (2 * SIZE) >= b1.row && (row - SIZE) < b1.row) || ((row - SIZE) <= b1.row + b1.size && (row - SIZE) > b1.row))
                        goto LOSE;
                if (((row - SIZE) + (2 * SIZE) > b1.row) && ((row - SIZE) < b1.row + b1.size))
                    if ((col - SIZE) + (2 * SIZE) == b1.col || (col - SIZE) == b1.col + b1.size)
                        goto LOSE;


                if ((b2.col + b2.size > (col - SIZE)) && (b2.col < (col - SIZE) + (2 * SIZE)))
                    if ((b2.row + b2.size >= (row - SIZE) && b2.row < (row - SIZE)) || (b2.row <= (row - SIZE) + (2 * SIZE) && b2.row > (row - SIZE)))
                        goto LOSE;
                if ((b2.row + b2.size > (row - SIZE)) && (b2.row < (row - SIZE) + (2 * SIZE)))
                    if (b2.col + b2.size == (col - SIZE) || b2.col == (col - SIZE) + (2 * SIZE))
                        goto LOSE;

                if (((col - SIZE) + (2 * SIZE) > b2.col) && ((col - SIZE) < b2.col + b2.size))
                    if (((row - SIZE) + (2 * SIZE) >= b2.row && (row - SIZE) < b2.row) || ((row - SIZE) <= b2.row + b2.size && (row - SIZE) > b2.row))
                        goto LOSE;
                if (((row - SIZE) + (2 * SIZE) > b2.row) && ((row - SIZE) < b2.row + b2.size))
                    if ((col - SIZE) + (2 * SIZE) == b2.col || (col - SIZE) == b2.col + b2.size)
                        goto LOSE;


                if ((b3.col + b3.size > (col - SIZE)) && (b3.col < (col - SIZE) + (2 * SIZE)))
                    if ((b3.row + b3.size >= (row - SIZE) && b3.row < (row - SIZE)) || (b3.row <= (row - SIZE) + (2 * SIZE) && b3.row > (row - SIZE)))
                        goto LOSE;
                if ((b3.row + b3.size > (row - SIZE)) && (b3.row < (row - SIZE) + (2 * SIZE)))
                    if (b3.col + b3.size == (col - SIZE) || b3.col == (col - SIZE) + (2 * SIZE))
                        goto LOSE;

                if (((col - SIZE) + (2 * SIZE) > b3.col) && ((col - SIZE) < b3.col + b3.size))
                    if (((row - SIZE) + (2 * SIZE) >= b3.row && (row - SIZE) < b3.row) || ((row - SIZE) <= b3.row + b3.size && (row - SIZE) > b3.row))
                        goto LOSE;
                if (((row - SIZE) + (2 * SIZE) > b3.row) && ((row - SIZE) < b3.row + b3.size))
                    if ((col - SIZE) + (2 * SIZE) == b3.col || (col - SIZE) == b3.col + b3.size)
                        goto LOSE;
         
        ////////////////////////////////////////////////////////////////////////

        //creates brick 1 and changes its row and column.
        b1.row = b1.row + b1.rdel;
        b1.col = b1.col + b1.cdel;

        // Check if the object has collided with the sizes of top
        if (b1.col > 239 - b1.size) {
            b1.col = 239 - b1.size;
            b1.cdel = -b1.cdel;
        }
        if (b1.col < 117) {
            b1.col = 117;
            b1.cdel = -b1.cdel;
        }
        if (b1.row > 77 - b1.size) {
            b1.row = 77 - b1.size;
            b1.rdel = -b1.rdel;
        }
        if (b1.row < 0) {
            b1.row = 0;
            b1.rdel = -b1.rdel;
        }

        //creates brick 2 and changes its row and column.
        b2.row = b2.row + b2.rdel;
        b2.col = b2.col + b2.cdel;

        // Check if the object has collided with the sizes of top
        if (b2.col > 239 - b2.size) {
            b2.col = 239 - b2.size;
            b2.cdel = -b2.cdel;
        }
        if (b2.col < 0) {
            b2.col = 0;
            b2.cdel = -b2.cdel;
        }
        if (b2.row > 159 - b2.size) {
            b2.row = 159 - b2.size;
            b2.rdel = -b2.rdel;
        }
        if (b2.row < 0) {
            b2.row = 0;
            b2.rdel = -b2.rdel;
        }

        //creates brick 2 and changes its row and column.
        b3.row = b3.row + b3.rdel;
        b3.col = b3.col + b3.cdel;

        // Check if the object has collided with the sizes of top
        if (b3.col > 111 - b3.size) {
            b3.col = 111 - b3.size;
            b3.cdel = -b3.cdel;
        }
        if (b3.col < 0) {
            b3.col = 0;
            b3.cdel = -b3.cdel;
        }
        if (b3.row > 159 - b3.size) {
            b3.row = 159 - b3.size;
            b3.rdel = -b3.rdel;
        }
        if (b3.row < 83) {
            b3.row = 83;
            b3.rdel = -b3.rdel;
        }

        ////////////////////////////////////////////////////////////////////////

        //drawing the face using raster circle and hollow rectangle. Erasing the
        //the previous face made and keeping the new one.

        waitForVblank();
        rasterCircleFace(oldrow, oldcol, oldsize, BLACK);
        rasterCircleFace(row, col, size, changeColor());

        waitForVblank();
        drawRect(b1.oldrow, b1.oldcol, b1.size, b1.size, BLACK);
        drawRect(b1.row, b1.col, b1.size, b1.size, YELLOW);

        waitForVblank();
        drawRect(b2.oldrow, b2.oldcol, b2.size, b2.size, BLACK);
        drawRect(b2.row, b2.col, b2.size, b2.size, RED);

        waitForVblank();
        drawRect(b3.oldrow, b3.oldcol, b3.size, b3.size, BLACK);
        drawRect(b3.row, b3.col, b3.size, b3.size, GREEN);

        grid();

        // Save the old location and old size
        oldrow = row;
        oldcol = col;

        b1.oldrow = b1.row;
        b1.oldcol = b1.col;

        b2.oldrow = b2.row;
        b2.oldcol = b2.col;

        b3.oldrow = b3.row;
        b3.oldcol = b3.col;

        ///////////////////////////////////WIN//////////////////////////////////

        int i, j;

        for (i = 0; i < 31; i++) {
            for (j = 209; j < 240; j++) {
                if (row == i && col == j) {
                    goto WIN;
                }
            }
        }

        ////////////////////////////////////////////////////////////////////////


        ///////////////////////////////SCORE////////////////////////////////////

        int m, n;

        for (m = 0; m < 80; m++) {
            for (n = 0; n < 120; n++) {
                if (row == m && col == n) {
                    score = 100;
                }
            }
        }
        for (m = 80; m < 160; m++) {
            for (n = 0; n < 120; n++) {
                if (row == m && col == n) {
                    score = 200;
                }
            }
        }
        for (m = 80; m < 160; m++) {
            for (n = 120; n < 240; n++) {
                if (row == m && col == n) {
                    score = 300;
                }
            }
        }
        for (m = 0; m < 80; m++) {
            for (n = 120; n < 240; n++) {
                if (row == m && col == n) {
                    score = 400;
                }
            }
        }

        ////////////////////////////////////////////////////////////////////////

        sprintf(timebuffer, "TIME: %d", OLDSECTIMER);
        drawString(151, 5, timebuffer, BLACK);
        sprintf(timebuffer, "TIME: %d", SECTIMER);
        drawString(151, 5, timebuffer, RED);

        sprintf(scorebuffer, "SCORE: %d", oldscore);
        drawString(140, 5, scorebuffer, BLACK);
        sprintf(scorebuffer, "SCORE: %d", score);
        drawString(140, 5, scorebuffer, RED);

        sprintf(finalscorebuffer, "FINAL SCORE: %d", oldfinalgamescore);
        drawString(150, 140, finalscorebuffer, BLACK);
        sprintf(finalscorebuffer, "FINAL SCORE: %d", finalgamescore);
        drawString(150, 140, finalscorebuffer, RED);

        oldfinalgamescore = finalgamescore;
        OLDSECTIMER = SECTIMER;
        oldscore = score;

        /////////////////////////////TIMER//////////////////////////////////////

        if(TIMER%8 == 0 && TIMER != 0){
            SECTIMER++;
            finalgamescore = score / SECTIMER;
        }

        ////////////////////////////////////////////////////////////////////////
        
        TIMER++;

    }
/////////////////////////////////////WIN SCREEN/////////////////////////////////
LOSE:
    drawRect(0, 0, 159, 239, BLACK);

    drawString(77, 67, gameover, RED);

    drawString(77, 67, gameover, RED);

    sprintf(timebuffer, "TIME: %d", SECTIMER);
    drawString(151, 5, timebuffer, RED);

    sprintf(scorebuffer, "SCORE: %d", score);
    drawString(129, 5, scorebuffer, RED);

    sprintf(finalscorebuffer, "OVERALL SCORE: %d", finalgamescore);
    drawString(140, 5, finalscorebuffer, RED);

    exit(0);

////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////LOSE SCREEN////////////////////////////////

WIN:
    drawRect(0, 0, 159, 239, BLACK);

    drawString(77, 50, win, GREEN);

    sprintf(timebuffer, "TIME: %d", SECTIMER);
    drawString(151, 5, timebuffer, GREEN);

    sprintf(scorebuffer, "SCORE: %d", score);
    drawString(129, 5, scorebuffer, GREEN);

    sprintf(finalscorebuffer, "OVERALL SCORE: %d", finalgamescore);
    drawString(140, 5, finalscorebuffer, GREEN);

////////////////////////////////////////////////////////////////////////////////
    
    return 0;

}